var OrientDB = require('orientjs');
var _ = require('lodash');
var async = require('async')
var config = require('./config.json')

const includeClass = ['ap', 'ap1']
const excludeClass = ['V']

var server = OrientDB({
    host: config.server.host,
    port: 2424,
    username: config.server.username,
    password: config.server.password
});

var ODatabase = OrientDB.ODatabase;
var dbSrc = new ODatabase({
   host:     config.server.host,
   port:     2424,
   username: config.sourceDb.username,
   password: config.sourceDb.password,
   name:     config.sourceDb.dbName
});

var dbDest = new ODatabase({
   host:     config.server.host,
   port:     2424,
   username: config.destDb.username,
   password: config.destDb.password,
   name:     config.destDb.dbName
});

// var dbSrc = server.use({
//     name: config.sourceDb.dbName,
//     username: config.sourceDb.username,
//     password: config.sourceDb.password
// });

// var dbDest = server.use({
//     name: config.destDb.dbName,
//     username: config.destDb.username,
//     password: config.destDb.password
// })

// listAllClass(dbDest)


module.exports = function copyDb() {
    listAllClass(dbDest)
}

////////////////////////////////////////////////////////// functions ///////////////////////////////////////
function listAllClass(database) {
    dbDest.class.list()
    .then(function (classes) {
        console.log(classes)
        async.each(classes, insertoClass, function(err, result) {
            if(err) {
                console.log(err)
            } else {
                console.log('done')
            }
        })
    })
}

function insertoClass(classRec, callback) {
    if(_.find(includeClass, function(item) { return item ==classRec.name} )) {
        dbSrc.query("select  from "+classRec.name)
            .then(function (vRec) {
                insertIntoDb(classRec.name, vRec, callback);
            })
    } else
        callback()
}

function insertIntoDb(className, contentJson, callback) {
    let keys = ['']
    keys = _.keys(contentJson[0])
    keys = _.filter(keys, function (item) {
        return !item.startsWith('@')
    })
    if (keys.length > 0) {
        let values = _.map(contentJson, function (item) {
            let result = [];
            for (let key in keys) {
                result.push('"' + item[keys[key]] + '"')
            }
            return '( ' + result.join(',') + ')';
        })
        console.log(values);
        let query = 'INSERT INTO ' + className + '(' + keys.join(',') + ') VALUES ' + values;
        dbDest.exec(query)
            .then(function (result) {
                console.log(result)
                callback();
            })
    } else{
        callback();
    }
}